#!/usr/bin/perl -w
# $Id: asp-pw.pl,v 1.7 2001/10/19 21:52:33 will Exp $
# Copyright 2000, 2001 Sun Microsystems, Inc., All rights reserved.
#
# unified create/modify script for users.
#
# author: Jonathan Mayer <jmayer@cobalt.com>

use strict;
use lib qw( /usr/sausalito/perl );
use CCE;
umask(022);

my $DEBUG = 0;

# cASP (Chili!Soft)
my $ASP_initdir      = "/etc/rc.d/init.d";
my $ASP_servicename  = "asp-apache-3000";
my $ASP_adminname    = "asp-admin-5100";
my $ASP_home         = '/home/chiliasp';
my $ASP_vhostctrl    = "$ASP_home/INSTALL/vhostctl";
my $ASP_appconf      = '.aspconf';
my $ASP_pwfile       = "$ASP_home/admin/conf/service.pwd";
my $ASP_htpasswd     = "/usr/bin/htpasswd";
my $ASP_perms        = '0400';
my $Adminuser        = 'admin';

# system("$ASP_htpasswd -b $ASP_pwfile $Adminuser $newpasswd > /dev/null 2>&1; /bin/chmod 400 $ASP_pwfile > /dev/null 2>&1") if (-x $ASP_htpasswd);

# connect:
my $cce = new CCE;
$cce->connectfd();

# retrieve info
my $oid = $cce->event_oid();
my $old = $cce->event_old(); # old values
my $new = $cce->event_new(); # recently changed values only
my $obj = $cce->event_object(); # composite "new" object.

# verify this is $Adminuser
# perhaps this check can be done with UI permissions?
if ($old->{name} =~ /^$Adminuser$/) {
	my $newpasswd = $new->{password};
	$newpasswd =~ s/([^\\])([\n\;])/$1\\$2/g;
	
	if ((-x $ASP_htpasswd) && $newpasswd) {
		Sauce::Util::modifyfile($ASP_pwfile);
		system("$ASP_htpasswd -b $ASP_pwfile $old->{name} \"$newpasswd\" > /dev/null 2>&1");
		Sauce::Util::chmodfile($ASP_perms, $ASP_pwfile);
	}

	open(DEBUG, ">>/tmp/asp-pw");
	print DEBUG `date`;
	print DEBUG "$ASP_htpasswd -b $ASP_pwfile $old->{name} \"$newpasswd\" > /dev/null 2>&1; /bin/chmod $ASP_perms $ASP_pwfile\n";
	close(DEBUG);

}

$cce->bye('SUCCESS');
exit 0;

