#!/usr/bin/perl -w
# $Id: asp-toggle.pl,v 1.11 2001/11/28 03:48:46 pbaltz Exp $
# Copyright 2000, 2001 Sun Microsystems, Inc., All rights reserved.
# Asp-Apache Virtual Site Participation Monitor
# Will DeHaan <null@sun.com>
#
# Test whether any virtual sites are using Asp.
# en/disable asp-apache-3000 if necessary
#
# we determine whether asp is "enabled" if any virtual site is subscribed.

use lib qw(/usr/sausalito/perl);

my $DEBUG = 0;

use CCE;
my $cce = new CCE;
$cce->connectfd();

my $object = $cce->event_object();

# Test proposed Vsite.Asp state

my ($oid, $enabled);
my ($ok, $siteAsp) = $cce->get($cce->event_oid(), 'Asp');

$enabled = 1 if ($siteAsp->{enabled});

# search the namespace to make this more efficient, since this is now possible
unless($enabled)
{
	my @voids = $cce->find('Vsite', { 'Asp.enabled' => 1 });
    
    if (scalar(@voids))
    {
        $enabled = 1;
    }

    $DEBUG && warn("Asp enabled is $enabled");
}

my ($sysoid) = $cce->find("System");
$DEBUG && warn "Found system OID $sysoid\n";

my ($status, $obj) = $cce->get($sysoid, 'Asp');

# fix chkconfig information:
if ($obj->{enabled} && !$enabled) 
{
	$DEBUG && warn "Calling CCE to disable System.Asp enabled...\n";
	$ok = $cce->set($sysoid, 'Asp', {'enabled' => 0});
} 
elsif (!$obj->{enabled} && $enabled) 
{
	$DEBUG && warn "Calling CCE to enable System.Asp enabled...\n";
	$ok = $cce->set($sysoid, 'Asp', {'enabled' => 1});
}

# do not block w/failures
$cce->bye('SUCCESS');
exit(0);

