#!/usr/bin/perl
# $Id: asp-vsite.pl,v 1.9.2.1 2002/03/20 10:51:32 pbaltz Exp $
# Copyright 2000, 2001 Sun Microsystems, Inc., All rights reserved.
# ASP virtual site service
# Will DeHaan <null@sun.com>

my $ASP_home        = "/home/chiliasp";
my $ASP_vhostctrl   = "$ASP_home/INSTALL/vhostctl";
my $ASP_servicename = 'asp-apache-3000';

use lib qw(/usr/sausalito/perl);
use CCE;
use Sauce::Util;
use Base::HomeDir qw(homedir_get_group_dir);

my $DEBUG = 0;
$DEBUG && warn "$0 ".`date`;

#
###

my $cce = new CCE;
$cce->connectfd();

my $vsite = $cce->event_object();
my $old = $cce->event_old();
my($ok, $asp) = $cce->get($cce->event_oid(), 'Asp');
my $enabled = $asp->{enabled};

unless($ok)
{
	$DEBUG && warn "$0 could not find ".$cce->event_oid()." Asp namespace\n";
	$cce->bye('FAIL');
	exit 1;
}

# we only need to call Chili!soft config script when deleting a site.  
if ($cce->event_is_destroy() && $old->{fqdn})
{
	my $fqdn = $old->{fqdn};
	my $ret = system("$ASP_vhostctrl engine=$ASP_home/$ASP_servicename vhost=$fqdn enable=no > /dev/null 2>&1");
	$cce->bye('SUCCESS'); # ignore the system return value on site delete.  
	exit 0;
}

# Find our site name...
my ($group, $fqdn, $vol)  = ($vsite->{name}, $vsite->{fqdn}, $vsite->{volume});

# group name is assigned during create so it may not be there when
# this handler runs
if ($cce->event_is_create() && $group eq '')
{
	$cce->bye('DEFER');
	exit(0);
}

my $doc_root = homedir_get_group_dir($group, $vol). "/web/";

$DEBUG && warn "$enabled vsite-asp control for $fqdn, $group with web root $doc_root\n";

# configure Apache .asp and .asa handlers
if (!Sauce::Util::editfile('/etc/httpd/conf/vhosts/'.$group, 
	*edit_generic_vhost, $asp->{enabled}, $fqdn))
{
	$cce->bye('FAIL', '[[base-apache.cantEditVhost]]');
	exit(1);
}

# per-site casp configuration system call
my $yesno = $enabled ? 'yes' : 'no';
my $ret = system("$ASP_vhostctrl engine=$ASP_home/$ASP_servicename vhost=$fqdn enable=$yesno > /dev/null 2>&1");

if($ret && !$enabled) 
{
	# non-blocking exit for failed disable attempt
	# $cce->bye('FAIL');
	# exit(1);
}

$cce->bye('SUCCESS');
exit(0);

###
#

sub edit_generic_vhost
{
	my ($in, $out, $enabled, $fqdn) = @_;

	my $ASP_home = '/home/chiliasp';

	my $vhost_conf =<<EOF;
AddHandler chiliasp .asp
AddHandler chiliasp .asa
EOF

	# append line marking the end of the section specifically owned by the VirtualHost
	my $end_mark = "# end of VirtualHost owned section\n";

	while (<$in>)
	{
		if (/^\s*<VirtualHost/ ... /^\s*<\/VirtualHost>/) 
		{
			if(/^\s*<\/VirtualHost>/) 
			{
				print $out $vhost_conf if ($enabled);
				print $out $_;
			} 
			elsif ($_ !~ /^\s*AddHandler\s+chiliasp\s+/) 
			{
				print $out $_;
			}
		}
		else
		{
			print $out $_;
		}
	}

	return 1;
}
